#include <stdio.h>
#include <ctype.h>
#include "tokenizer.h"

static char *g_Buf;
static char *g_BufPtr;

int tokenizer_Init(char *str)
{
    g_Buf = str;
    g_BufPtr = g_Buf;
    return 0;
}

#define STR_NUM_BUF_SIZE    128

int token_Get(TOKEN *&token)
{
    char    str_num[STR_NUM_BUF_SIZE];
    int     idx;
    double  d;

    // skip non printable characters
    while ((*g_BufPtr <= ' ') && (*g_BufPtr != '\0'))
        g_BufPtr ++;

    // test for number
    if (isdigit(*g_BufPtr)) {
        for (idx = 0; (idx < STR_NUM_BUF_SIZE) && isdigit(*g_BufPtr); idx++, g_BufPtr ++)
            str_num[idx] = *g_BufPtr;
        if ((idx < STR_NUM_BUF_SIZE - 1) && (*g_BufPtr == '.')) {
            str_num[idx] = '.';
            idx ++;
            g_BufPtr ++;
            for (; (idx < STR_NUM_BUF_SIZE) && isdigit(*g_BufPtr); idx++, g_BufPtr ++)
                str_num[idx] = *g_BufPtr;
        }
        str_num[idx] = '\0';

        if (1 != sscanf(str_num, "%lf", &d)) {
            fprintf(stderr, "Invalid number in input buffer\n");
            goto FNC_EXIT_ERR;
        }
        token->t = TT_VAL_NUM;
        token->num = d;
        return 0;
    }

    // test operator
    switch (*g_BufPtr++) {
        case '-':
            token->op = TOT_MINUS;
            break;
        case '+':
            token->op = TOT_PLUS;
            break;
        case '*':
            token->op = TOT_MUL;
            break;
        case '/':
            token->op = TOT_DIV;
            break;
        case '<':
            token->op = TOT_LTHAN;
            break;
        case '>':
            token->op = TOT_GTHAN;
            break;
        case '\0':
            goto FNC_EXIT_ERR;
        default:
            fprintf(stderr, "Invalid operator in input buffer\n");
            goto FNC_EXIT_ERR;
    }
    token->t = TT_OPERATOR;
    return 0;

FNC_EXIT_ERR:
    token = NULL;
    return -1;
}
