#ifndef _TOKENIZER_H_
#define _TOKENIZER_H_ 1

#include <list>

typedef enum {
    TT_VAL_NUM = 1,
    TT_OPERATOR
} TOKEN_TYPE;

typedef enum {
    TOT_MINUS = 1,
    TOT_PLUS,
    TOT_MUL,
    TOT_DIV,
    TOT_LTHAN,
    TOT_GTHAN,
} TOKEN_OPERATOR_TYPE;

typedef struct _token   TOKEN;

typedef struct _token {
    TOKEN_TYPE              t;
    union {
        double              num;
        TOKEN_OPERATOR_TYPE op;
    };
} TOKEN;

typedef std::list<TOKEN *>      LIST_TOKEN;
typedef LIST_TOKEN::iterator    LIST_TOKEN_IT;

int tokenizer_Init(char *str);
int token_Get(TOKEN *&token);

#endif /* _TOKENIZER_H_ */
